#!/usr/bin/env bash

CURRENT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" >/dev/null 2>&1 && pwd)"

ALLOWED_BLOCK_SIZE_VALUES="2x2 3x2 3x3 4x4"
ALLOWED_DIFFICULTY_VALUES="easy medium hard nightmare"
GRIDS_COUNT=10

for BLOCK_SIZE in ${ALLOWED_BLOCK_SIZE_VALUES}; do
  for DIFFICULTY in ${ALLOWED_DIFFICULTY_VALUES}; do
    echo "Block size: ${BLOCK_SIZE} / Difficulty: ${DIFFICULTY}"
    for i in $(seq ${GRIDS_COUNT}); do
      # Generate grid candidate
      GRID="$(python ${CURRENT_DIR}/generate.py ${BLOCK_SIZE} ${DIFFICULTY} | tail -n 1)"
      # Ensure grid can be resolve without any assumption
      CAN_BE_SOLVED="$(python ${CURRENT_DIR}/solve.py ${BLOCK_SIZE} ${GRID} | tail -n 1)"
      if [ "${CAN_BE_SOLVED}" == "Ok" ]; then
        echo "${BLOCK_SIZE} ${DIFFICULTY} ${GRID}"
      else
        echo "FAILED: ${BLOCK_SIZE} ${DIFFICULTY} ${GRID}"
      fi
    done
  done
done
